function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { defineComponent, $prefix, $props, $setup, props, setup as _setup } from "@dftvue2-opentiny/vue-common";
import PcTemplate from "./pc.js";
import MobileFirstTemplate from "./mobile-first.js";
import { renderless, api } from "@dftvue2-opentiny/vue-renderless/flowchart/node";
import { IconYes, IconClose } from "@dftvue2-opentiny/vue-icon";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import ResizeObserver from "@dftvue2-opentiny/vue-renderless/common/deps/ResizeObserver";
import "@dftvue2-opentiny/vue-theme/flowchart/index.css";
var template = function template2(mode) {
  if ("pc" === (process.env.TINY_MODE || mode)) {
    return PcTemplate;
  }
  if ("mobile-first" === (process.env.TINY_MODE || mode)) {
    return MobileFirstTemplate;
  }
  return PcTemplate;
};
var $constants = {};
var createNode = function createNode2(name, status, label, date, items, row, col, other) {
  var info = {
    status,
    label,
    date,
    items,
    row,
    col,
    other
  };
  return {
    name,
    info
  };
};
var createLink = function createLink2(from, to, p, status, style, other) {
  var info = {
    status,
    style: style || "solid",
    other
  };
  return {
    from,
    to,
    p,
    info
  };
};
var createItem = function createItem2(key, name, role, status, comment, date, other) {
  return {
    key,
    name,
    role,
    status,
    comment,
    date,
    other
  };
};
var createConfig = function createConfig2() {
  return {
    width: 1024,
    height: 420,
    rows: 8,
    cols: 8,
    status: {
      1: "complete",
      2: "ongoing",
      3: "pending",
      4: "fail"
    },
    colors: {
      1: "#1890ff",
      2: "#096dd9",
      3: "#d9d9d9",
      4: "#f5222d"
    },
    background: "#fff",
    statusComplete: 1,
    statusOngoing: 2,
    statusFail: 4,
    anchor: "center",
    iconWrapperSize: 24,
    iconSize: 20,
    iconSvgSize: 14,
    labelSpacing: 8,
    labelWidth: 80,
    labelHeight: 60,
    labelDateColor: "#999",
    listWidth: 62,
    listThreshold: 1,
    listIconSize: 20,
    listBorderColor: "#d9d9d9",
    listIconColor: "#999",
    headUrl: "",
    headSize: 20,
    drawLink: null,
    styleLink: null,
    styleHoverLink: null,
    hoverHit: 3,
    checkItemStatus: null,
    font: '12px "Microsoft YaHei"',
    delay: 10,
    adjustPos: null,
    radius: 4,
    thin: true
  };
};
var Flowchart = defineComponent({
  name: $prefix + "Flowchart",
  props: _extends({}, $props, {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    data: Object,
    config: Object
  }),
  setup: function setup(props2, context) {
    return $setup({
      props: props2,
      context,
      template
    });
  }
});
var __vue2_script = defineComponent({
  props: [].concat(props, ["node", "config", "titleClass"]),
  components: {
    TinyIconYes: IconYes(),
    TinyIconClose: IconClose()
  },
  setup: function setup2(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    key: _vm.state.nodeName,
    class: ["layout-" + _vm.state.nodeLayout, "size-" + _vm.state.nodeSize, "status-" + _vm.state.nodeStatus, "absolute z-20 h-6", {
      "sm:h-4": _vm.state.sizeMini,
      "sm:h-8": _vm.state.sizeMedium
    }],
    style: {
      width: _vm.state.nodeWidth + "px"
    },
    attrs: {
      "data-tag": "tiny-flowchart-node"
    }
  }, [_c("div", {
    ref: "icon",
    class: ["border-solid rounded-full flex items-center justify-center", "absolute z-0 translate-x-1 translate-y-1 w-4 h-4 text-base", "hover:ring hover:ring-color-bg-2 stroke-2 cursor-pointer", {
      "sm:w-2 sm:h-2": _vm.state.sizeMini,
      "sm:w-6 sm:h-6 sm:text-2xl": _vm.state.sizeMedium
    }, {
      "border-4 bg-clip-padding border-color-brand-hover-subtle bg-color-border-focus": _vm.state.isSmall && _vm.state.statOngoing || !_vm.state.isSmall && _vm.state.statOngoing && _vm.state.sizeMedium,
      "border-0 border-color-bg-1 bg-color-border-focus": !_vm.state.isSmall && _vm.state.statOngoing && !_vm.state.sizeMedium,
      "border-2 border-color-border bg-color-bg-1": _vm.state.statNotStarted
    }, _vm.state.isActive ? {
      "border-2 bg-clip-padding border-color-brand-hover-subtle bg-color-border-focus": _vm.state.statCompleted,
      "border-2 bg-clip-padding border-color-brand-hover-subtle bg-color-error": _vm.state.statFail
    } : {
      "border-2 border-color-border-focus bg-color-bg-1": _vm.state.statCompleted,
      "border-2 border-color-error bg-color-bg-1": _vm.state.statFail
    }]
  }, [!_vm.state.sizeMini || _vm.state.sizeMini && _vm.state.isSmall ? [_c("span", {
    staticClass: "inline-flex origin-center stroke-color-bg-1",
    class: _vm.state.isSmall ? "scale-75" : "scale-95"
  }, [_vm.state.statCompleted ? [_c("tiny-icon-yes", {
    class: {
      "stroke-color-border-focus": !_vm.state.isActive
    }
  })] : _vm._e(), _vm.state.statFail ? [_c("tiny-icon-close", {
    class: {
      "stroke-color-error": !_vm.state.isActive
    }
  })] : _vm._e()], 2)] : _vm._e()], 2), _c("div", {
    ref: "title",
    class: _vm.m("absolute z-0 translate-x-1", _vm.state.layUpdown ? "top-6" : "left-6 translate-y-1", _vm.state.layUpdown ? {
      "sm:top-4": _vm.state.sizeMini,
      "sm:top-8": _vm.state.sizeMedium
    } : {
      "sm:left-4": _vm.state.sizeMini,
      "sm:left-8": _vm.state.sizeMedium
    }, _vm.titleClass || ""),
    style: {
      maxWidth: _vm.state.titleMaxWidth + "px",
      left: _vm.state.layUpdown ? "-" + _vm.state.posLeft + "px" : ""
    }
  }, [_vm._l(["title", "subtitle", "auxi"], function(key) {
    return [_vm.state[key].show ? _c("div", {
      key,
      class: ["truncate", _vm.state.layUpdown ? "text-center" : "text-left", key === "title" && _vm.state.sizeMedium ? "text-sm" : "text-xs", _vm.state.isSmall ? {
        "leading-5": key === "title",
        "leading-4": key !== "title"
      } : {
        "leading-6": key === "title" && _vm.state.sizeMedium,
        "leading-5": key !== "title" && _vm.state.sizeMedium || key === "title" && _vm.state.sizeSmall,
        "leading-4": key !== "title" && _vm.state.sizeSmall || _vm.state.sizeMini
      }, {
        "text-color-icon-focus": _vm.state.statOngoing,
        "text-color-text-primary": key === "title" && _vm.state.statCompleted,
        "text-color-error": key === "title" && _vm.state.statFail,
        "text-color-icon-secondary": key === "title" && _vm.state.statNotStarted,
        "text-color-icon-placeholder": key !== "title" && !_vm.state.statOngoing
      }],
      attrs: {
        "title": _vm.state[key].text
      }
    }, [_vm._v(" " + _vm._s(_vm.state[key].text) + " ")]) : _vm._e()];
  })], 2)]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var Node = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var resizeMixin = function resizeMixin2(_ref) {
  var apiPrefix = _ref.apiPrefix, refName = _ref.refName, nodeWrapperSize = _ref.nodeWrapperSize;
  apiPrefix = apiPrefix || "rszmx";
  refName = refName || "chart";
  nodeWrapperSize = nodeWrapperSize || 32;
  var observer = apiPrefix + "ResizeObserver";
  var observed = apiPrefix + "ResizeObserved";
  return {
    mounted: function mounted() {
      var _this = this;
      this.$nextTick(function() {
        var observedElement = _this.$el.parentNode;
        if (observedElement) {
          _this[observer] = new ResizeObserver(function() {
            window.requestAnimationFrame(function() {
              if (_this.$refs[refName]) {
                _this.$refs[refName].refresh({
                  graphWidth: observedElement.offsetWidth,
                  adjustX: -nodeWrapperSize / 2
                });
              }
            });
          });
          _this[observer].observe(observedElement);
          _this[observed] = observedElement;
        }
      });
    },
    beforeUnmount: function beforeUnmount() {
      if (this[observer]) {
        this[observer].unobserve(this[observed]);
        this[observer].disconnect();
        this[observer] = null;
        this[observed] = null;
      }
    }
  };
};
var resizeMixin$1 = resizeMixin;
var version = "2.8.0";
Flowchart.install = function(Vue) {
  Vue.component(Flowchart.name, Flowchart);
};
Flowchart.version = version;
Flowchart.createNode = createNode;
Flowchart.createLink = createLink;
Flowchart.createItem = createItem;
Flowchart.createConfig = createConfig;
Flowchart.Node = Node;
Flowchart.resizeMixin = resizeMixin$1;
export {
  Flowchart as default
};
